/*
	fuzzy_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:


	MODIFICATIONS:
	5-Oct-99	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions

// flag signifying main loop is to terminate
int fuzzy_module_done = 0;

//signal handler for ^C
extern "C" void fuzzy_module_quit(int sig);
void fuzzy_module_quit(int sig)
{
	fuzzy_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int fuzzy_module_run();

int fuzzy_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);

	// set the SIGINT handler
	signal(SIGINT, fuzzy_module_quit);

	// enter main loop
	while(!fuzzy_module_done)
	{

		timer->wait();
	}

	// Delete Modules

	// Delete Timer
	delete timer;
}

