/*
	fuzzy_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	5-Oct-99	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "fuzzyn.hh" 	// fuzzyFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *fuzzy_cmd = NULL;
static RCS_STAT_CHANNEL *fuzzy_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// fuzzy
	fuzzy_cmd = new RCS_CMD_CHANNEL(fuzzyFormat, "fuzzy_cmd", "fuzzy_modulesvr", "fuzzy_module.nml");
	if(NULL == fuzzy_cmd)
		return -1;
	if(!fuzzy_cmd->valid())
		return -1;

	fuzzy_stat = new RCS_STAT_CHANNEL(fuzzyFormat, "fuzzy_sts", "fuzzy_modulesvr", "fuzzy_module.nml");
	if(NULL == fuzzy_stat)
		return -1;
	if(!fuzzy_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "fuzzy_modulesvr", "fuzzy_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// fuzzy
	if(NULL != fuzzy_cmd)
	{
		delete fuzzy_cmd;
		fuzzy_cmd = NULL;
	}

	if(NULL != fuzzy_stat)
	{
		delete fuzzy_stat;
		fuzzy_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int fuzzy_modulesvr_run();

int fuzzy_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

